'use strict';

var _require = require('lodash');

var defaults = _require.defaults;
var pick = _require.pick;

var defaultDefault = require('./default-default');

module.exports = function contentFromFilename(repos, config) {
  var _config, branch, filename, addRepo, _ref, content, sha;

  return regeneratorRuntime.async(function contentFromFilename$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        config = defaults(config, {
          branch: 'master'
        });

        _config = config;
        branch = _config.branch;
        filename = _config.filename;
        addRepo = defaultDefault(pick(config, ['user', 'repo']));
        context$1$0.prev = 5;
        context$1$0.next = 8;
        return regeneratorRuntime.awrap(repos.getContent(addRepo({
          ref: branch,
          path: filename
        })));

      case 8:
        _ref = context$1$0.sent;
        content = _ref.content;
        sha = _ref.sha;

        if (sha) {
          context$1$0.next = 13;
          break;
        }

        return context$1$0.abrupt('return', Promise.reject(new Error('Couldn\'t find ' + filename + '.')));

      case 13:
        return context$1$0.abrupt('return', Promise.resolve({
          content: new Buffer(content, 'base64').toString(),
          sha: sha
        }));

      case 16:
        context$1$0.prev = 16;
        context$1$0.t0 = context$1$0['catch'](5);
        return context$1$0.abrupt('return', Promise.reject(context$1$0.t0));

      case 19:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[5, 16]]);
};