'use strict';

require('babel-core/polyfill');

var _require = require('lodash');

var defaults = _require.defaults;
var mapValues = _require.mapValues;

var GitHubApi = require('github');
var promisify = require('es6-promisify');

var contentFromFilename = require('./content-from-filename');
var updateFileWithContent = require('./update-file-with-content');

module.exports = function callee$0$0(config, callback) {
  var _config, _config$branch, branch, token, transform, github, repos, _ref, content, sha, newContent, transformedConfig, update, _config2, push, pr;

  return regeneratorRuntime.async(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        _config = config;
        _config$branch = _config.branch;
        branch = _config$branch === undefined ? 'master' : _config$branch;
        token = _config.token;
        transform = _config.transform;
        context$1$0.prev = 5;
        github = new GitHubApi({
          version: '3.0.0'
        });

        github.authenticate({ type: 'oauth', token: token });

        repos = mapValues(github.repos, promisify);
        context$1$0.next = 11;
        return regeneratorRuntime.awrap(contentFromFilename(repos, config));

      case 11:
        _ref = context$1$0.sent;
        content = _ref.content;
        sha = _ref.sha;
        newContent = transform(content);
        transformedConfig = {};

        if (typeof newContent === 'string') transformedConfig.content = newContent;else transformedConfig = newContent;

        config = defaults(transformedConfig, { sha: sha }, config);

        context$1$0.next = 20;
        return regeneratorRuntime.awrap(updateFileWithContent(repos, github, config));

      case 20:
        update = context$1$0.sent;
        _config2 = config;
        push = _config2.push;
        pr = _config2.pr;

        if (!(push || !pr)) {
          context$1$0.next = 26;
          break;
        }

        return context$1$0.abrupt('return', callback(null, update));

      case 26:

        github.pullRequests.create(defaults(pr, config, {
          base: branch,
          head: config.newBranch || update.commit.sha
        }), callback);
        context$1$0.next = 32;
        break;

      case 29:
        context$1$0.prev = 29;
        context$1$0.t0 = context$1$0['catch'](5);

        callback(context$1$0.t0);

      case 32:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[5, 29]]);
};