'use strict';

var _require = require('lodash');

var pick = _require.pick;

var promisify = require('es6-promisify');

var defaultDefault = require('./default-default');

module.exports = function callee$0$0(repos, github, config) {
  var content, filename, sha, branch, author, comitter, message, addRepo, newBranch, head, update;
  return regeneratorRuntime.async(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        content = config.content;
        filename = config.filename;
        sha = config.sha;
        branch = config.branch;
        author = config.author;
        comitter = config.comitter;
        message = config.message || 'chore: updated ' + filename;
        addRepo = defaultDefault(pick(config, ['user', 'repo']));
        context$1$0.prev = 8;
        newBranch = !config.push ? config.newBranch || sha : null;

        if (!newBranch) {
          context$1$0.next = 16;
          break;
        }

        context$1$0.next = 13;
        return regeneratorRuntime.awrap(promisify(github.gitdata.getReference)(addRepo({ ref: 'heads/' + branch })));

      case 13:
        head = context$1$0.sent;
        context$1$0.next = 16;
        return regeneratorRuntime.awrap(promisify(github.gitdata.createReference)(addRepo({
          sha: head.object.sha,
          ref: 'refs/heads/' + newBranch
        })));

      case 16:
        context$1$0.next = 18;
        return regeneratorRuntime.awrap(repos.updateFile(addRepo({
          path: filename,
          message: message,
          content: new Buffer(content).toString('base64'),
          sha: sha,
          branch: newBranch || branch,
          author: author,
          comitter: comitter
        })));

      case 18:
        update = context$1$0.sent;
        return context$1$0.abrupt('return', Promise.resolve(update));

      case 22:
        context$1$0.prev = 22;
        context$1$0.t0 = context$1$0['catch'](8);
        return context$1$0.abrupt('return', Promise.reject(context$1$0.t0));

      case 25:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[8, 22]]);
};